-- INITAL SETUP

function init(a,b)
local array = {}
for i = 1, a do
array[i] = b
end
return array
end
bb={}

-- CONFIGURATIONS

bb.limit = 9 -- Bouncing limit every shoot.

-- ENGINE

bb.value=init(32,{})
bb.state=init(32,{})
bb.img=init(32,{})
bb.x=init(32,{})
bb.y=init(32,{})
bb.dir=init(32,{})
bb.wpn=init(32,{})
bb.allow=init(32,false)
for all=1,32 do
	bb.value[all]=init(20,bb.limit)
	bb.state[all]=init(20,false)
	bb.img[all]=init(20,"")
	bb.x[all]=init(20,0)
	bb.y[all]=init(20,0)
	bb.dir[all]=init(20,0)
	bb.wpn[all]=init(20,0)
end

addhook("attack","bb.atk")
function bb.atk(id)
	for rr=1,20 do
		if (player(id,"weapontype")<41 or player(id,"weapontype")>=90) then 
			if bb.allow[id] and bb.state[id][rr]==false then
				bb.x[id][rr]=player(id,"x")
				bb.y[id][rr]=player(id,"y")
				bb.dir[id][rr]=player(id,"rot") if bb.dir[id][rr]<0 then bb.dir[id][rr]=bb.dir[id][rr]+360 end
				bb.state[id][rr]=true
				bb.wpn[id][rr]=player(id,"weapontype")
				bb.img[id][rr]=image("gfx/bouncingbullet/bullet.png",bb.x[id][rr],bb.y[id][rr],1)
				break
		
			end
		end
	end
end
addhook("always","bb.alw")
function bb.alw()
	for id=1,32 do
		if player(id,"exists") then
			if itemtype(player(id,"weapontype"),"slot")~=4 then
				bb.allow[id]=true
			else 
				bb.allow[id]=false
			end
		end
		for id2=1,32 do
			for rr=1,20 do
				if player(id,"exists") and id~=id2 and player(id2,"exists") and player(id2,"health")>0 then
					if player(id,"team")~=player(id2,"team") and bb.state[id][rr]==true then
						local inrad=math.rad(bb.dir[id][rr]-180)
						local s,c=-math.sin(inrad)*4,math.cos(inrad)*4
						bb.x[id][rr]=bb.x[id][rr]+s
						bb.y[id][rr]=bb.y[id][rr]+c
						imagepos(bb.img[id][rr],bb.x[id][rr],bb.y[id][rr],bb.dir[id][rr])
						local tx,ty=math.floor(bb.x[id][rr]/32),math.floor(bb.y[id][rr]/32)
						if tile(tx,ty,"wall") then
							if bb.value[id][rr]>0 then
								bb.value[id][rr]=bb.value[id][rr]-1
								local otx,oty=math.floor((bb.x[id][rr]-s)/32),math.floor((bb.y[id][rr]-c)/32)
								local dir2=math.atan2(otx-tx,oty-ty)*math.deg(math.pi)/math.pi
								bb.dir[id][rr]=(dir2-math.deg(math.pi))-(bb.dir[id][rr]-dir2)
							else
								bb.state[id][rr]=false
								freeimage(bb.img[id][rr])
								bb.value[id][rr]=bb.limit
							end
						else
							local x1,y1,x2,y2=bb.x[id][rr],bb.y[id][rr],player(id2,"x"),player(id2,"y")							
							local dist=math.sqrt((x2-x1)^2+(y2-y1)^2)
							if dist < 15 then
								local itemname=itemtype(bb.wpn[id][rr],"name")
								local wdmg= itemtype(bb.wpn[id][rr],"dmg")
								if player(id2,"health")>wdmg then
									parse("sethealth "..id2.." "..player(id2,"health")-wdmg)
									parse('effect "colorsmoke" '..player(id2,'x')..' '..player(id2,'y')..' 10 2 255 0 0')
								else
									parse('customkill '..id..' "bouncing '..itemname..' bullet" '..id2)
									parse('effect "colorsmoke" '..player(id2,'x')..' '..player(id2,'y')..' 10 10 255 100 100')
								end
								bb.state[id][rr]=false
								freeimage(bb.img[id][rr])
								bb.value[id][rr]=bb.limit
								bb.img[id][rr]=""
							end
						end
					elseif player(id,"team")==player(id2,"team") and bb.state[id][rr]==true then
						local x1,y1,x2,y2=bb.x[id][rr],bb.y[id][rr],player(id2,"x"),player(id2,"y")							
						local dist=math.sqrt((x2-x1)^2+(y2-y1)^2)
						local inrad=math.rad(bb.dir[id][rr]-180)
						local tx,ty=math.floor(bb.x[id][rr]/32),math.floor(bb.y[id][rr]/32)
						local s,c=-math.sin(inrad)*4,math.cos(inrad)*4
						if dist < 20 then
							local otx,oty=math.floor((bb.x[id][rr]-s)/32),math.floor((bb.y[id][rr]-c)/32)
							local dir2=math.atan2(otx-tx,oty-ty)*math.deg(math.pi)/math.pi
							bb.dir[id][rr]=(dir2-math.deg(math.pi))-(bb.dir[id][rr]-dir2)
						end
					end
				end
			end
		end
	end
end

addhook("endround","bb.endr")
function bb.endr()
	for id=1,32 do
		for rr=1,20 do
			bb.state[id][rr]=false
			if bb.img[id][rr]~="" then
				freeimage(bb.img[id][rr])
			end
		end
	end
end